#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Generado por PyGG <juacarrag@gmail.com>

import gtk

from GladeConnect import *


HABILITADO, PROGRAMA, DESCRIPCION, COMANDO = range(4)

class LanzaConfig(GladeConnect):

    def __init__(self, path, icono):
        GladeConnect.__init__(self, 'glade/pylanza.glade','wnPylanza')
	self.wnPylanza.set_icon_from_file(icono)
	self.icono = icono
        self.path = path
        self.crea_columnas()
        self.carga_datos()
        self.bloquear_botones(True)
        
        
    def bloquear_botones(self, bloquear=True):  
        if bloquear:
            self.btnEditar.set_sensitive(False)
            self.btnBorrar.set_sensitive(False)
        else:
            self.btnEditar.set_sensitive(True)
            self.btnBorrar.set_sensitive(True)
    
    def crea_columnas(self):
        self.modelo = gtk.ListStore(bool, str,str,str)
        
        renderer = gtk.CellRendererToggle()
        renderer.connect('toggled', 
                          self.on_habilitado,
                          self.modelo)

        col = gtk.TreeViewColumn('Habilitado',
                                 renderer,
                                 active=HABILITADO)
        self.treeVista.append_column(col)
        
        col = gtk.TreeViewColumn('Programa',
                                 gtk.CellRendererText(),
                                 text=PROGRAMA)
        self.treeVista.append_column(col)
        
        
        self.treeVista.set_model(self.modelo)
        
   
    def carga_datos(self):
        try:
            archivo = open(self.path, 'r')
        except:
            print 'Error de lectura'
            return
            
        for linea in archivo:
            
            if linea[0] <> '#' and linea[0] <> ' ' and len(linea) > 1:
                
                if linea[-1] == '\n':
                    linea = linea[:-1]
                    
                datos = linea.split(':')
                
                if len(datos) < 4:
                    for i in range(0,4 - len(datos)):
                        datos.append(None)
                elif len(datos) > 4:
                    datos = datos[:4]
                
                if datos[0] == 'True' or datos[0] == '1':
                    datos[0] = 1
                else:
                    datos[0] = 0          
            
                self.modelo.append(datos)
    
    def guardar_vista(self):
        try:
            archivo = open(self.path, 'w')
        except:
            print 'Error de lectura'
            return
        
        archivo.write("#pylanza.rc\n#")
        archivo.write("Habilitado:Programa:Descripcion:Comando\n\n")
        for datos in self.modelo:
            archivo.write("%s:%s:%s:%s\n" % (datos[0], datos[1],
                                             datos[2], datos[3]))

    def on_habilitado(self, cell, path, model):
        iter = model.get_iter((int(path),))
        fixed = model.get_value(iter, HABILITADO)
        fixed = not fixed
        model.set(iter, HABILITADO, fixed)
        
    def on_btnBorrar_clicked(self,*args):
        modelo, puntero = self.treeVista.get_selection().get_selected()
        modelo.remove(puntero)
        self.bloquear_botones(True)

    def on_btnCerrar_clicked(self,*args):
        self.guardar_vista()
        if __name__ == '__main__':
            gtk.main_quit()
        else:
            self.wnPylanza.destroy()

    def on_btnEditar_clicked(self,*args):
        modelo, puntero = self.treeVista.get_selection().get_selected()
        dlg = dlgLanzaConfig(self.icono)
        dlg.entPrograma.set_text(modelo[puntero][PROGRAMA])
        dlg.entDescripcion.set_text(modelo[puntero][DESCRIPCION])
        dlg.entComando.set_text(modelo[puntero][COMANDO])
        response = dlg.dlgPylanza.run()
        if response == gtk.RESPONSE_OK:
            modelo.set(puntero, PROGRAMA, dlg.entPrograma.get_text())
            modelo.set(puntero, DESCRIPCION, dlg.entDescripcion.get_text())
            modelo.set(puntero, COMANDO, dlg.entComando.get_text())
            

    def on_btnNuevo_clicked(self,*args):
        dlg = dlgLanzaConfig(self.icono)
        response = dlg.dlgPylanza.run()
        if response == gtk.RESPONSE_OK:
            self.modelo.append([True,
                                dlg.entPrograma.get_text(),
                                dlg.entDescripcion.get_text(),
                                dlg.entComando.get_text()])
            
            
    def on_treeVista_row_activated(self, tree=None, iter=None, column=None):
        self.on_btnEditar_clicked()
    
    def on_treeVista_cursor_changed(self, tree=None, iter=None, column=None):
        self.bloquear_botones(False)


class dlgLanzaConfig(GladeConnect):

    def __init__(self, icono):
        GladeConnect.__init__(self, 'glade/pylanza.glade','dlgPylanza')
	self.dlgPylanza.set_icon_from_file(icono)
        
    def on_btnAceptar_clicked(self, btn):
        self.dlgPylanza.hide()
        
    def on_btnCancelar_clicked(self, btn):
        self.dlgPylanza.hide()
        

if __name__ == '__main__':
    app = LanzaConfig('pylanza.rc')
    gtk.main()
