#!/usr/bin/env python
# -*- coding: utf-8 -*-

import gtk
import os

from pyLanzaConfig import LanzaConfig

PATH_CONFIG = '/etc/pylanza/pylanza.rc'
PATH_ICONO = '/usr/share/icons/hicolor/22x22/apps/pylanza.png'

acerca_de_activo = False

def make_menu(event_button, event_time, icon):
    menu = gtk.Menu()
    try:
        archivo = open(PATH_CONFIG, 'r')
    except:
        print 'Error de lectura'
        app_menu(menu, event_button, event_time, icon)
        return
        
    for linea in archivo:
        if linea[0] <> '#' and linea[0] <> ' ' \
        and len(linea) > 1 and linea[0] <> '0':
            if linea[-1] == '\n':
                linea = linea[:-1]
            datos = linea.split(':')
            item = gtk.MenuItem(datos[1])
            item.connect('activate', on_item_click, datos[3], datos[2])   
            menu.append(item)    
    app_menu(menu, event_button, event_time, icon)
    menu.popup(None, None,
        gtk.status_icon_position_menu, event_button,
        event_time, icon)
    menu.show_all()

def app_menu(menu, event_button, event_time, icon):
    item = gtk.SeparatorMenuItem()
    menu.append(item)
    
    #item = gtk.MenuItem(gtk.STOCK_PROPERTIES)
    item = gtk.MenuItem('Propiedades')
    item.connect('activate', on_click)
    menu.append(item)
    
    #item = gtk.MenuItem(gtk.STOCK_ABOUT)
    item = gtk.MenuItem('Acerca de')
    item.render_icon(gtk.STOCK_ABOUT, gtk.ICON_SIZE_MENU)
    
    item.connect('activate', on_acerca_de)
    menu.append(item)    

    item = gtk.SeparatorMenuItem()
    menu.append(item)

    item = gtk.MenuItem('Salir')
    item.connect('activate', on_salir)
    menu.append(item)

    menu.popup(None, None,
        gtk.status_icon_position_menu, event_button,
        event_time, icon)
    menu.show_all()

def on_salir(widget):
    gtk.main_quit()

def on_dlg_hide(dlg, evt):
    global acerca_de_activo
    
    dlg.hide()
    acerca_de_activo = False
    
def on_acerca_de(self):  
    global acerca_de_activo
    
    if not acerca_de_activo:
        acerca_de_activo = True
        dialog = gtk.AboutDialog()
        dialog.set_name("PyLanza")
        dialog.set_version('1.0')
        dialog.set_authors(['Juan Carrasco <juacarrag@gmail.com>'])
        dialog.set_copyright("\302\251 Copyright 200x juacarra")
        dialog.set_license("""PyLanza es software libre; puede redistribuirlo y/o
modificarlo bajo los términos de la Licencia Pública
General de GNU tal como la publica la Free Software
Foundation; tanto en la versión 2 de la Licencia como
(a su elección) cualquier versión posterior.

PyLanza se distribuye con la esperanza de que será
útil,pero SIN NINGUNA GARANTÍA; sin incluso la
garantía implicada de MERCANTIBILIDAD o
ADECUACIÓN PARA UN PROPÓSITO PARTICULAR. Vea la
Licencia Pública General de GNU para más detalles.

Debería haber recibido una copia de la Licencia pública
General de GNU junto con PyLanza; si no, escriba a la
Free Software Foundation, Inc,59 Temple Place, Suite
330, Boston, MA 02111-1307, Estados Unidos de
América""")
                
        dialog.connect ("response", on_dlg_hide)
        dialog.show()
    

def on_item_click(menuItem, comando, descripcion):
    
    os.system("gksu '%s'  -m '%s' -g" % (comando, descripcion))
    
def on_right_click(icon, event_button, event_time):
    make_menu(event_button, event_time, icon)
    
    
def on_click(widget):
    config = LanzaConfig(PATH_CONFIG, PATH_ICONO)

def LaunchPyLanza(parent=None):
    icon = gtk.status_icon_new_from_file(PATH_ICONO)
    icon.connect('popup-menu', on_right_click)
    icon.connect('activate', on_click)

if __name__ == '__main__':
    LaunchPyLanza()
    gtk.main()
